//Copyright (c) 2003, Alexander Oganezov
//ALL RIGHTS RESERVED

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "draw.h"
#include "defines.h"
#include "vroom.h"
#include "levels.h"
#include "generate.h"
#include <dirent.h>
#include "statusbar.h"
#include "areaio.h"
#include "options.h"

	struct t_tmproom
	{
		int val;
		int r_id;
		int exits[10];
	};

char areaname[200];
GtkWidget *fileselection, *statusbar, *dl3,*preview_dialog,*root,*canvas;
GtkWidget *notebook, *fileselection3,*fileselection2,*eedlg;
GnomeCanvasGroup *group;
extern _vroom;
extern _vexitnode;
extern _level;
GtkWidget *gen_dialog;
struct _vroom *myroom;
struct _vroom *_curroom;
struct _vroom* head;
int whattodo,cntr,curx, cury,isrx, isry;
//int _level;
struct _level *head_level;
struct _level *cur_level;
int misactive; //gridhelper active or not
int mautoscroll; //autoscroll active or not
int ee_row_selected;
GtkWidget *wgpl;
int fittag,helpers_tag;

//initalizes things here
void set_root(GtkWidget *w) {
	double mx_scroll;
	GtkSettings *settings;
	GtkWidget *scwind;		
	char *home;
	char *mb_dir;
	char *conf_file;
	char *cppp;
	DIR *tmpdr;
		
		
	whattodo=0;
	memset(areaname,0x0,200);
	tmpdr=0;
	home=getenv("HOME");

	mb_dir=malloc(sizeof(char)*(strlen(home)+100));
	conf_file=malloc(sizeof(char)*(strlen(home)+100));
	cppp=malloc(sizeof(char)*(strlen(home)+strlen(PACKAGE_DATA_DIR)+300));

	strcpy(mb_dir,home);
	strcat(mb_dir,"/.mudsbuilder");

	tmpdr=opendir(mb_dir);
		
	if (tmpdr==0) 
	{
		g_print("Creating %s\n",mb_dir);
		mkdir(mb_dir,0777);

		g_print("Creating config files\n");
		strcpy(cppp,"cp ");
		strcat(cppp,PACKAGE_DATA_DIR);
		strcat(cppp,"/etc/* ");
		strcat(cppp,mb_dir);
		strcat(cppp,"/");
		system(cppp);
		
		strcpy(conf_file,PACKAGE_DATA_DIR);
		strcat(conf_file,"/etc/gereacreator.conf");
			
	}
	else {
		closedir(tmpdr);
		
		strcpy(conf_file,mb_dir);
		strcat(conf_file,"/gereacreator.conf");
	}

	load_options(conf_file);
	settings=gtk_settings_get_default();
	g_object_set(G_OBJECT(settings),"gtk-font-name",APP_FONT,NULL);
		
	mx_scroll=GSIZE*RSIZE2;
	root=w;
	canvas=lookup_widget(root,"canvas1");
	notebook=lookup_widget(root,"notebook1");
		
	gnome_canvas_set_scroll_region((GnomeCanvas*)canvas,
	0.0,0.0,mx_scroll,mx_scroll);
	gnome_canvas_scroll_to((GnomeCanvas*)canvas,0,0);
	group=gnome_canvas_root((GnomeCanvas*)canvas);
		
	
	cntr=1; curx=-1; cury=-1;
		
	head_level=new__level();
	head_level->canvas=canvas;
	head_level->group=group;
		
	head_level->lev_id=0;
	cur_level=head_level;
	cur_level->_zoom=1.0;
		
	draw_grid(cur_level,GRID_COLOR);
		
	statusbar=lookup_widget(root,"statusbar1");
	status_msg("Click anywhere on grid to start!");
	//free(home);
	free(conf_file);
	free(mb_dir);
	free(cppp);
}


void
on_window1_destroy                     (GtkObject       *object,
						gpointer         user_data)
{
	gtk_main_quit();
}



	//when key is pressed
gboolean
on_canvas1_key_press_event             (GtkWidget       *widget,
						GdkEventKey     *event,
						gpointer         user_data)
{
	double daexits[8];
	char buf[300];
	double xm[]=
	{-RSIZE3,0,RSIZE3,-RSIZE3,0,RSIZE3,-RSIZE3,0,RSIZE3};
	double ym[]=
	{RSIZE3,RSIZE3,RSIZE3,0,0,0,-RSIZE3,-RSIZE3,-RSIZE3};

	struct _vroom *oldroom;
	int i;
	int ek;
	int scx,scy,wx,wy;
	double xx1,yy1,xx2,yy2;
	struct _vroom *tmpvroom;
	double tmpdae;
	struct _vexitnode *tmpvnode, *oldvnode;
	int scrollx, scrolly;
	int tsx, tsy;

	if (curx==-1 || cury==-1) {
		status_msg("You must select starting location first!");
		return FALSE;
	}
		
		
	for (i=0; i<8; i++) daexits[i]=0;
	ek=event->keyval-65456;
	//	g_print("%d\n",ek);
		
	if (ek==49 || ek==-49) return TRUE;
	if (ek==-6) {
	on_rooms_source1_activate(0,0); return TRUE; }

	if (ek==-1) { on_button11_clicked(0,0); return TRUE;}
	if (ek==-35) { on_generatebtn_clicked(0,0);return TRUE; }

	if (ek==-91) 
	{
		on_zoom_in1_activate(0,0);
		return TRUE;
	}
		
	if (ek==-90)
	{
		on_zoom_out1_activate(0,0);
		return TRUE;
	}

	if (ek==-96)
	{
		on_fit_to_screen1_activate(0,0);	
		return TRUE;
	}
		
	if (ek==0)
	{
		on_edit_exits_clicked(0,0);
		return TRUE;
	}

	//no key on pad or delete pressed
	if ((ek>9 || ek<1 || ek==5) && ek!=79 && ek!=-5 && ek!=-3)
	{
		status_msg("Unrecognized key pressed");
		return TRUE;	
	}
	else
	{
		status_msg("You can use numeric keypad now");
	}
		
	if (head && _curroom->rlevel!=cur_level)
	switch_to_current_level();
		
		
	if (ek==-5)
	{
		if (curx!=-1 && cury!=-1) 
		{
			switch_to_current_level();
			go_level(1);
		}
		return;
	}

	if (ek==-3)
	{	
		if (curx!=-1 && cury!=-1) 
		{
			switch_to_current_level();
			go_level(-1);
		}
		return;
	}

	if (ek!=79 && ek!=-5 && ek!=-3) 
	{
		curx+=xm[ek-1];
		cury+=ym[ek-1];
//autoscroll
		if (mautoscroll==1)
		{
			gnome_canvas_get_scroll_offsets((GnomeCanvas*)(cur_level->canvas),
								&scrollx, &scrolly);
			gtk_window_get_size((GtkWindow*)root,&wx, &wy);

			
			tsx=(scrollx+wx-100);
			tsy=(scrolly+wy-100);
			
			
			if (curx>(tsx-80)/(cur_level->_zoom))
			{
				gnome_canvas_scroll_to((GnomeCanvas*)(cur_level->canvas),
				(int)((curx+tsx-300)/2)*(cur_level->_zoom),(int)scrolly);
			}
			
			if (curx<(scrollx+60)/(cur_level->_zoom))
			{
				gnome_canvas_scroll_to((GnomeCanvas*)(cur_level->canvas),
				(int)((curx+scrollx-300)/2)*(cur_level->_zoom),(int)scrolly);
			}

//scrolling y
			if (cury>(tsy-80)/(cur_level->_zoom))
			{
				gnome_canvas_scroll_to((GnomeCanvas*)(cur_level->canvas),
				scrollx,(int)((cury+tsy-300)/2)*(cur_level->_zoom));
			}
		
			if (cury<(scrolly+60)/(cur_level->_zoom))
			{
				gnome_canvas_scroll_to((GnomeCanvas*)(cur_level->canvas),
				scrollx,(int)((cury+scrolly-300)/2)*(cur_level->_zoom));
			}
		}	
//end autoscroll			
		
		if (curx<0 || cury<0) {
			curx-=xm[ek-1];
			cury-=ym[ek-1];
			return TRUE;
		}
			
		if (curx>GSIZE*RSIZE2-RSIZE2 || cury>GSIZE*RSIZE2-RSIZE2)
		{
			curx-=xm[ek-1];
			cury-=ym[ek-1];
			return TRUE;
		}
			
		sprintf(buf,"%i",cntr);
		if (ek<5) daexits[7-(ek-1)]=1;
		if (ek>5) daexits[7-(ek-2)]=1;

		//if room exists at that location - just switch to it
		tmpvroom=head;
		while (tmpvroom!=0)
		{				
			if (tmpvroom->x==curx && tmpvroom->y==cury && 
			tmpvroom->rlevel==cur_level)
			{
				set_exits(tmpvroom,daexits);
				for (i=0; i<4; i++)
				{	
					tmpdae=daexits[i];
					daexits[i]=daexits[7-i];
					daexits[7-i]=tmpdae;
				}
				set_exits(_curroom,daexits);
				//linking roomz
				link_rooms(tmpvroom,_curroom,daexits);
				set_curroom(tmpvroom);
				return KPRET;
			}
			tmpvroom=tmpvroom->next;
		}


		//creating new room
		myroom=(struct _vroom*)new_vroom();
		new_room(myroom,buf,curx,cury);
		//setting up exits of new room created
		set_exits(myroom,daexits);
		//setting up exits of current room
		for (i=0; i<4; i++)
		{	
			tmpdae=daexits[i];
			daexits[i]=daexits[7-i];
			daexits[7-i]=tmpdae;
		}

		set_exits(_curroom,daexits);
			
		//linking roomz
		link_rooms(myroom,_curroom,daexits);

		//relinking list of rooms
		myroom->next=head;
		head->prev=myroom;
		head=myroom;
			
		set_curroom(myroom);
		cntr++;

	} 
	else  
	{
		//deleting room;
		if (_curroom!=head) 
		{
			if (_curroom->prev!=0)
			_curroom->prev->next=_curroom->next;
			
			if (_curroom->next!=0) _curroom->next->prev=_curroom->prev;
		} else  head=_curroom->next;
			

		gtk_object_destroy((GtkObject*)_curroom->rectangle);
		gtk_object_destroy((GtkObject*)_curroom->text);
			
		if (head!=0) 
		{
			for (i=0; i<8; i++) 
			{
				if (_curroom->rexit[i]) 
				{
					gtk_object_destroy((GtkObject*)_curroom->rexit[i]);
					if (_curroom->room_ptr[i] && _curroom->room_ptr[i]->rexit[7-i]!=0) 
					{
						gtk_object_destroy(
						(GtkObject*) _curroom->room_ptr[i]->rexit[7-i]);	
						_curroom->room_ptr[i]->room_ptr[7-i]=0;
						_curroom->room_ptr[i]->rexit[7-i]=0;
					}
				}
				gnome_canvas_points_unref(_curroom->points[i]);
			}
			
			if (_curroom->down) 
			{
				gtk_object_destroy((GtkObject*)_curroom->vdown);
				gtk_object_destroy((GtkObject*)_curroom->down->vup);
				_curroom->down->up=0;
				_curroom->down->vup=0;
				_curroom->down=0;
			}
			
			
			if (_curroom->up) 
			{
				gtk_object_destroy((GtkObject*)_curroom->vup);
				gtk_object_destroy((GtkObject*)_curroom->up->vdown);
				_curroom->up->vdown=0;
				_curroom->up->down=0;
				_curroom->down=0;
			}
			

			tmpvnode=_curroom->head_exit;

			//deleting misc exits
			while (tmpvnode!=0)
			{
				free(tmpvnode->ex_name);
				oldvnode=tmpvnode;
				tmpvnode=tmpvnode->next;
				gtk_object_destroy((GtkObject*)oldvnode->line);
				free(oldvnode);
			}
			
			level_destroy(_curroom->rlevel);
			free(_curroom);

			_curroom=head;	
			curx=_curroom->x;
			cury=_curroom->y;
			set_curroom(head);
		
			if (head) switch_to_current_level();
		}
		else 
		{
			curx=-1; cury=-1; cntr=1; 
			level_destroy(cur_level); 
			tmpvnode=_curroom->head_exit;
			
			//deleting misc exits
			while (tmpvnode!=0)
			{
				free(tmpvnode->ex_name);
				oldvnode=tmpvnode;
				tmpvnode=tmpvnode->next;
				gtk_object_destroy((GtkObject*)oldvnode->line);
				free(oldvnode);
			}
			_curroom=0;
			status_msg("Click anywhere on the grid to start");	
		}
	}
	return KPRET;
}


gboolean
on_canvas1_button_press_event          (GtkWidget       *widget,
						GdkEventButton  *event,
						gpointer         user_data)
{
	struct _vroom *tmpvroom;
	int cx,cy;
	char buf[300];
	int isroom;
	int gridx,gridy;
	int rz;
	int savedx,savedy;
	int i,checkx,checky;
		

	if (event->button!=1) return FALSE;

	status_msg("You can use numeric keypad now.");
	cx=(int)(event->x / cur_level->_zoom);
	cy=(int)(event->y / cur_level->_zoom);

	if (curx==-1 || cury==-1) 
	{
		curx=cx; 
		cury=cy;
			
		rz=RSIZE2;
			
		gridx=(int)((curx-RSIZE1) /rz);
		gridy=(int)((cury-RSIZE1) /rz);



		myroom=(struct _vroom*)new_vroom();
		sprintf(buf,"%i",cntr);
		curx=gridx*RSIZE2+RSIZE1;
		cury=gridy*RSIZE2+RSIZE1;
		new_room(myroom,buf,curx,cury);

		//check is done cause of load_area() in areaio.c
		if (head==0) 
		{
			myroom->next=0;
			myroom->prev=0;	
			head=myroom;
		} 
		else 
		{
			myroom->next=head;
			head->prev=myroom;
			head=myroom;
		}

		cntr++;
		isrx=gridx % 2;
		isry=gridy % 2;	

		_curroom=myroom;
		set_curroom(myroom);
	} 
	else // for if (curx==-1 || cury==-1)
	{
		savedx=curx;
		savedy=cury;
		curx=cx;
		cury=cy;

		rz=RSIZE2;
		gridx=(int)((curx-RSIZE1) /rz);
		gridy=(int)((cury-RSIZE1) /rz);

		if (gridx % 2 !=isrx || gridy % 2 !=isry) 
		{
			if (misactive==1)
			{
				show_helpers(cur_level,gridx, gridy );
				helpers_tag=gtk_timeout_add(4000,hide_helpers,0);
			}

			curx=savedx; cury=savedy;
			status_msg("This cell is reserved for exit");
			return FALSE;
		}
		
		curx=gridx*RSIZE2+RSIZE1;
		cury=gridy*RSIZE2+RSIZE1;

		//checking for existing room
		tmpvroom=head;

		while (tmpvroom!=0)
		{
			checkx=tmpvroom->x;
			checky=tmpvroom->y;

			if (checkx==curx && checky==cury && tmpvroom->rlevel==cur_level) 
			{
				set_curroom(tmpvroom);
				return FALSE;
			}
			tmpvroom=tmpvroom->next;
		}

		sprintf(buf,"%i",cntr);
		myroom=(struct _vroom*)new_vroom();
		new_room(myroom,buf,curx,cury);

		myroom->prev=0;
		myroom->next=head;
		head->prev=myroom;
		head=myroom;

		set_curroom(myroom);
		cntr++;
	}
		
  return TRUE;
}

	 


int set_curroom(struct _vroom* cr)
{

	if (!_curroom)
	{	
		gnome_canvas_item_set(cr->text,"fill-color",ACTIVE_TEXT_COLOR,NULL);
		gnome_canvas_item_set(cr->rectangle,"outline-color",ACTIVE_RECT_COLOR,NULL);
		_curroom=cr;
		return;
	}

	if (_curroom->edited!=1) 
	{
		gnome_canvas_item_set(_curroom->text,"fill-color",TEXT_COLOR,NULL);
		gnome_canvas_item_set(_curroom->rectangle,"outline-color",RECT_COLOR,NULL);
	} 
	else 
	{
		gnome_canvas_item_set(_curroom->text,"fill-color",TEXT_COLOR,NULL);
		gnome_canvas_item_set(_curroom->rectangle,"outline-color","brown",NULL);
	}
	
	_curroom=cr;

	if (_curroom->edited!=1) 
	{
		gnome_canvas_item_set(_curroom->text,"fill-color",ACTIVE_TEXT_COLOR,NULL);
		gnome_canvas_item_set(_curroom->rectangle,"outline-color",ACTIVE_RECT_COLOR,NULL);
	} 
	else 
	{
		gnome_canvas_item_set(_curroom->text,"fill-color",ACTIVE_TEXT_COLOR,NULL);
		gnome_canvas_item_set(_curroom->rectangle,"outline-color","orange",NULL); 
	}
}


//emulates keypress even on canvas - used by buttons on control table
int emulate_key_event(int nkey)
{
	GdkEventKey newkey;
	newkey.keyval=65456+nkey;
	on_canvas1_key_press_event(0,&newkey,0);
}


//south, west , north etc.. buttons
void on_button1_clicked (GtkButton *button, gpointer user_data)
{ emulate_key_event(7); }

void on_button2_clicked(GtkButton *button,gpointer user_data)
{ emulate_key_event(8); }

void on_button3_clicked(GtkButton *button, gpointer user_data)
{ emulate_key_event(9); }

void on_button4_clicked(GtkButton *button, gpointer user_data)
{ emulate_key_event(4); }

void on_button5_clicked(GtkButton *button, gpointer         user_data)
{ emulate_key_event(6); }

void on_button6_clicked(GtkButton       *button, gpointer         user_data)
{ emulate_key_event(1); }

void on_button7_clicked(GtkButton       *button, gpointer         user_data)
{ emulate_key_event(2); }

void on_button8_clicked(GtkButton       *button, gpointer         user_data)
{ emulate_key_event(3); }


void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct _vroom *tmpr;
	GtkWidget *cc;

	if (head) switch_to_current_level();
	cc=lookup_widget(root,"canvas1");

	tmpr=head;
	
	if (head==0) return;
	while (head!=0) emulate_key_event(79);

	
	_curroom=0;
	memset(areaname,0x0,200);
	if (cur_level->_zoom!=1.0)
	{
	cur_level->_zoom=1.0;
	gnome_canvas_set_pixels_per_unit((GnomeCanvas*)cc,1.0);	
	}
	gnome_canvas_scroll_to((GnomeCanvas*)(cc),0,0);
	
	/* 
		timeout is used due to some wierd bug 
		if rooms exceed some number canvas sorta freezes 
		and causes segfault if we try to set its pixel per unit
	*/
	//timeout removed in 0.5.3
	//fittag=gtk_timeout_add(200,(gpointer)do_fit_screen,0);


/*	gnome_canvas_set_pixels_per_unit(
		(GnomeCanvas*)cur_level->canvas,cur_level->_zoom);
	gnome_canvas_scroll_to((GnomeCanvas*)(cur_level->canvas),0,0);
*/
}


gboolean do_fit_screen(int a)
{
	on_fit_to_screen1_activate(0,0);
	gtk_timeout_remove(fittag);
	return TRUE;
}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	char *hm;
	char *buf;

	whattodo=0;	
	
	fileselection=create_fileselection1();
	hm=getenv("HOME");
	buf=malloc(sizeof(char)*(strlen(hm)+40));
	strcpy(buf,hm);
	strcat(buf,"/");	
	gtk_file_selection_set_filename((GtkFileSelection*)fileselection,buf);
	free(hm);
	free(buf);

	gtk_widget_show(fileselection);
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (head==0)
	{
		mdialog_msg("Cannot save empty area");
	//	status_msg("Cannot save empty area");
		return;
	}
	if (strlen(areaname)==0) on_save_as1_activate(menuitem,user_data);
	else save_area(areaname);
}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	char *hm;
	char *buf;
	if (head==0)
	{	
		mdialog_msg("Cannot save empty area");
		//status_msg("Cannot save empty area");
		return;
	}
	whattodo=1;
	fileselection=create_fileselection1();

	hm=getenv("HOME");
	buf=malloc(sizeof(char)*(strlen(hm)+40));
	strcpy(buf,hm);
	strcat(buf,"/");	
	gtk_file_selection_set_filename((GtkFileSelection*)fileselection,buf);
	free(hm);
	free(buf);

	gtk_widget_show(fileselection);
}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ gtk_main_quit(); }



void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *wac;
	wac=create_aboutger();
	gtk_widget_show(wac);
	
//	lookup_widgets(root);	
}


void
on_rooms_source1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	char *fnn;
	char *home_dir;
	
	if (head==0)
	{
		status_msg("No rooms exist!");
		return;
	}

	home_dir=getenv("HOME");
	fnn=malloc(sizeof(char)*(strlen(home_dir)+strlen(MUDLIB_TEMPLATE)+50));
	strcpy(fnn,home_dir);
	strcat(fnn,"/.mudsbuilder/");
	strcat(fnn,MUDLIB_TEMPLATE);

	generate_room(fnn,_curroom,0,0);

	free(home_dir);
	free(fnn);
}



void
on_zoom_in1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (cur_level->_zoom<ZOOM_MAX) 
 	{ 
		cur_level->_zoom+=ZOOM_STEP;
		gnome_canvas_set_pixels_per_unit(
			(GnomeCanvas*)cur_level->canvas,cur_level->_zoom);
	}
}


void
on_zoom_out1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if (cur_level->_zoom>ZOOM_MIN)
	{
		cur_level->_zoom-=ZOOM_STEP;
		gnome_canvas_set_pixels_per_unit(
			(GnomeCanvas*)cur_level->canvas,cur_level->_zoom);
	}
}


void
on_fit_to_screen1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	cur_level->_zoom=1.0;
	

	gnome_canvas_set_pixels_per_unit(
		(GnomeCanvas*)cur_level->canvas,cur_level->_zoom);
}


gboolean
on_vbox1_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                       gpointer         user_data)

{
	on_canvas1_key_press_event(widget,event,user_data);
}

void
on_button9_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{ emulate_key_event(79); }






//going up
void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	if (curx!=-1 && cury!=-1) 
	{
		switch_to_current_level();
		go_level(1);
	}
}


//going down
void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	if (curx!=-1 && cury!=-1) 
	{
		switch_to_current_level();
		go_level(-1);
	}
}


gboolean
on_window1_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  on_canvas1_key_press_event(widget,event,user_data);
  return TRUE;
}



void
on_generatebtn_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

	char *ml;
	char *hm;
	
	GtkWidget *e7,*e1,*e2,*e3,*e4,*e5,*e6, *e8;
	if (head==0) 
	{
		status_msg("In order to generate you must first create area");
		return;
	}

	gen_dialog=create_generate_dialog();
	gtk_widget_show(gen_dialog);
	e1=lookup_widget(gen_dialog,"entry3");
	e2=lookup_widget(gen_dialog,"entry4");
	e3=lookup_widget(gen_dialog,"entry5");
	e4=lookup_widget(gen_dialog,"entry6");
	e5=lookup_widget(gen_dialog,"entry7");
	e6=lookup_widget(gen_dialog,"entry8");
	e7=lookup_widget(gen_dialog,"entry2");
	e8=lookup_widget(gen_dialog,"entry9");
	
//	g_print("CREATOR IS: %s\n",CREATOR_NAME);
	gtk_entry_set_text((GtkEntry*)e1,ROOM_PREFIX);
	gtk_entry_set_text((GtkEntry*)e2,AREA_NAME);
	gtk_entry_set_text((GtkEntry*)e3,FILE_EXT);
	gtk_entry_set_text((GtkEntry*)e4,COMMENT);
	gtk_entry_set_text((GtkEntry*)e5,CREATOR_NAME);
	gtk_entry_set_text((GtkEntry*)e6,MUDLIB_TEMPLATE);
	gtk_entry_set_text((GtkEntry*)e8,ROOM_POSTFIX);

	hm=getenv("HOME");
	ml=malloc(sizeof(char)*(strlen(hm)+strlen(AREA_NAME)+30));
	strcpy(ml,hm);
	strcat(ml,"/.mudsbuilder/");
	strcat(ml,AREA_NAME);
	strcat(ml,"/");
	gtk_entry_set_text((GtkEntry*)e7,ml);
	free(hm);
	free(ml);
}


//save room clicked
void
on_button21_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkTextBuffer *gb;
	GtkTextIter start_iter;
	GtkTextIter end_iter;
	
	char *hm;
	char *fnm;
	FILE *of;
	int sof;
	char *buf_m;
	
	if (strlen(areaname)==0)
	{
		mdialog_msg("Error: You must save area first!");
	}
	else
	{
		_curroom->edited=1;
		gnome_canvas_item_set(
			_curroom->rectangle,
			"outline-color","brown",NULL);
	
		//saving room
		hm=getenv("HOME");
		fnm=malloc(sizeof(char)*(strlen(hm)+strlen(areaname)+100));

		strcpy(fnm,hm);
		strcat(fnm,"/.mudsbuilder/.tmpsaved_");
		strcat(fnm,(char*)basename(areaname));
		strcat(fnm,"_room");
		strcat(fnm,_curroom->id);
	
		of=fopen(fnm,"w");
		gb=gtk_text_view_get_buffer(
			(GtkTextView*)lookup_widget(preview_dialog,"textview1"));
		sof=gtk_text_buffer_get_char_count(gb);
	
		gtk_text_buffer_get_start_iter(gb,&start_iter);
		gtk_text_buffer_get_end_iter(gb,&end_iter);
		buf_m=gtk_text_buffer_get_text(gb,&start_iter,&end_iter,TRUE);

		fwrite(buf_m,sizeof(char),strlen(buf_m),of);
		fclose(of);

		gtk_widget_destroy(preview_dialog);
		free(hm);
		free(fnm);
	}
}


void
on_notebook1_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        guint            page_num,
                                        gpointer         user_data)
{
	char clev[100];
	struct _level *cll;
	int lint;
	
	GtkWidget *llab;
	GtkWidget *child;


	child=gtk_notebook_get_nth_page(
	(GtkNotebook*)notebook,page_num);


	llab=gtk_notebook_get_tab_label(
		(GtkNotebook*)notebook,child);
	
	strcpy(clev,gtk_label_get_text((GtkLabel*)llab));
	
	lint=get_map_level(clev);
	
	
	if (cur_level->lev_id==lint) return;
	
	cll=cur_level;
	
	while (cll->prev!=0) cll=cll->prev;

	while (cll!=0)
	{
		if (lint==cll->lev_id)
		{
			cur_level=cll;
			return;
		}

		cll=cll->next;
	}
	
}


void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

	char *cex[]={ 
		SOUTHWEST_IS,
		SOUTH_IS,
		SOUTHEAST_IS,
		WEST_IS,
		EAST_IS,
		NORTHWEST_IS,
		NORTH_IS,
		NORTHEAST_IS};

	GtkWidget *combo1;

	struct _vroom *tmp;
	struct _vexitnode *t_e_n;
	int i;
	char *_data[1][2];
	GList *items=NULL;
	GtkWidget *clist;


	if (curx==-1 || cury==-1) return;

	
	dl3=create_dialog3();
	gtk_widget_show(dl3);
	
	combo1=lookup_widget(dl3,"combo1");

	
	tmp=head;

	while (tmp!=0)
	{
		if (tmp->rlevel->lev_id==_curroom->rlevel->lev_id)
		{
			items=g_list_append(items,tmp->id);
		}
		tmp=tmp->next;
	}

	gtk_combo_set_popdown_strings((GtkCombo*)combo1,items);

	clist=lookup_widget(dl3,"clist2");
	_data[0][0]=malloc(sizeof(char)*100);
	_data[0][1]=malloc(sizeof(char)*(strlen(AREA_NAME)+100));

	for (i=0; i<8; i++)
	{
		if (_curroom->room_ptr[i]!=0)
		{
			strcpy(_data[0][0],cex[i]);
			strcpy(_data[0][1],AREA_NAME);
			strcat(_data[0][1],_curroom->room_ptr[i]->id);
			gtk_clist_append(
			(GtkCList*)clist,_data[0]);
		}
	}
	
	if (_curroom->up) {
		strcpy(_data[0][0],UP_IS);
		strcpy(_data[0][1],AREA_NAME);
		strcat(_data[0][1],_curroom->up->id);
			gtk_clist_append(
			(GtkCList*)clist,_data[0]);
	}

	if (_curroom->down) {
		strcpy(_data[0][0],DOWN_IS);
		strcpy(_data[0][1],AREA_NAME);
		strcat(_data[0][1],_curroom->down->id);
			gtk_clist_append(
			(GtkCList*)clist,_data[0]);
	}


	t_e_n=_curroom->head_exit;
	
	while (t_e_n!=0)
	{
		strcpy(_data[0][0],t_e_n->ex_name);
		strcpy(_data[0][1],AREA_NAME);
		strcat(_data[0][1],t_e_n->room_ptr->id);
		t_e_n=t_e_n->next;
		
			gtk_clist_append(
			(GtkCList*)clist,_data[0]);
	}
	
	

	free(_data[0][0]);
	free(_data[0][1]);

}

void
on_button27_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gtk_object_destroy((GtkObject*)dl3); }


void
on_button28_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	
	char c_entry1[100];
	char c_entry2[100];
	struct _vexitnode *new_vexit;
	struct _vroom *tmpr;
	GtkWidget *entry;
	GtkWidget *ex_name_entry;
	GtkWidget *combo1;
	GtkTextBuffer *mb;
	int i_entry;


	combo1=lookup_widget(dl3,"combo1");
	ex_name_entry=lookup_widget(dl3,"entry1");
	entry=((GtkCombo*)combo1)->entry;

	strcpy(c_entry1,gtk_entry_get_text((GtkEntry*)ex_name_entry));
	strcpy(c_entry2,gtk_entry_get_text((GtkEntry*)entry));
	i_entry=atoi(c_entry2);
	if (strlen(c_entry1)==0)
	{
		mdialog_msg("Exit name should not be empty");
		return;
	}
	
	new_vexit=malloc(sizeof(struct _vexitnode));
	new_vexit->ex_name=malloc(sizeof(char)*(strlen(c_entry1)+1));
	strcpy(new_vexit->ex_name,c_entry1);
	
	tmpr=head;
	int found_entry;
	found_entry=0;
	while (tmpr!=0)
	{
		if (strcmp(tmpr->id,c_entry2)==0 ) {
			new_vexit->room_ptr=tmpr;
			found_entry=1;

			if (tmpr->rlevel!=cur_level)
			{
				found_entry=-1;
			}
		}
		tmpr=tmpr->next;
	}
	
	if (found_entry==0)
	{
		mdialog_msg("No such room"); return;
	}

	if (found_entry==-1)
	{
		mdialog_msg("Cannot link to room on different level"); return;
	}

	
	new_vexit->prev=0;
	new_vexit->next=_curroom->head_exit;
	if (_curroom->head_exit!=0) _curroom->head_exit->prev=new_vexit;

	_curroom->head_exit=new_vexit;
	
	GnomeCanvasPoints *pz;
	pz=gnome_canvas_points_new(2);
	pz->coords[0]=_curroom->x+RSIZE1;
	pz->coords[1]=_curroom->y+RSIZE1;
	pz->coords[2]=_curroom->head_exit->room_ptr->x+RSIZE1;
	pz->coords[3]=_curroom->head_exit->room_ptr->y+RSIZE1;
	
	_curroom->head_exit->line=gnome_canvas_item_new(
	cur_level->group,
	GNOME_TYPE_CANVAS_LINE,
	"points",pz,
	"fill_color",EXIT_COLOR,
	"last_arrowhead",TRUE,
	"arrow_shape_a",14.0,
	"arrow_shape_b",19.0,
	"arrow_shape_c",4.0,
	NULL);
	gnome_canvas_points_unref(pz);
	
	
	gtk_object_destroy((GtkObject*)dl3);
}


void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	on_rooms_source1_activate((GtkMenuItem*)button,user_data);	
}



//fileselection dialog ok button clicked
void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	char *name;
	name=(gchar*)
	gtk_file_selection_get_filename((GtkFileSelection*)fileselection);

	strcpy(areaname,name);

	if (whattodo==1) save_area(areaname);
	else  { 
        load_area(areaname);
    }
	
	gtk_object_destroy((GtkObject*)fileselection);
	
}


void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_object_destroy((GtkObject*)fileselection);
}


void
on_button22_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_object_destroy((GtkObject*)preview_dialog);
}






char *get_areaname() { return areaname; }

void
on_button29_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	char *fnn;
	char *home_dir;
	
	_curroom->edited=0;
	
	gtk_object_destroy((GtkObject*)preview_dialog);

	if (head==0)
	{
		status_msg("No rooms exist!");
		return;
	}

	home_dir=getenv("HOME");
	fnn=malloc(sizeof(char)*(strlen(home_dir)+strlen(MUDLIB_TEMPLATE)+100));
	strcpy(fnn,home_dir);
	
	strcat(fnn,"/.mudsbuilder/");
	
	strcat(fnn,MUDLIB_TEMPLATE);
	
	generate_room(fnn,_curroom,0,0);
	set_curroom(_curroom);
	free(home_dir);
	free(fnn);
}



int set_globals(double a,double b, int c)
{
	curx=a; cury=b;
	isrx=(int)(a-RSIZE1)/(RSIZE2) % 2;
	isry=(int)(b-RSIZE1)/(RSIZE2) %2 ; 
	cntr=c;
}

int set_areaname(char *s)
{ 
	int ssize;
	ssize=strlen(s);

	if (ssize<200)
	strcpy(areaname,s); 
	else
	strncpy(areaname,s,199);

	return 1; 
}

void
on_button31_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_object_destroy((GtkObject*)gen_dialog);
}


void
on_button32_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	char 
		*gen_dir, 
		*room_prefix,
		*area_name,
		*file_extension,
		*comment_symbol,
		*creators_namee,
		*room_template,
		*room_postfix;
	int d_created;
	DIR *tmpdr;
	GtkWidget *wc;

	gen_dir=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry2"));
	room_prefix=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry3"));
	area_name=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry4"));
	file_extension=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry5"));
	comment_symbol=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry6"));
	room_postfix=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry9"));
	wc=lookup_widget(gen_dialog,"entry7");
	creators_namee=(char*)gtk_entry_get_text((GtkEntry*)wc);

	room_template=(char*)gtk_entry_get_text((GtkEntry*)lookup_widget(gen_dialog,"entry8"));
	
	
	
	strcpy(ROOM_PREFIX,room_prefix);
	strcpy(AREA_NAME,area_name);
	strcpy(FILE_EXT,file_extension);
	strcpy(CREATOR_NAME,creators_namee);
	strcpy(MUDLIB_TEMPLATE,room_template);
	strcpy(ROOM_POSTFIX,room_postfix);




	tmpdr=opendir(gen_dir);
	d_created=0;

	if (tmpdr==0)
	{
		g_print("Unable to open dir\n");
		d_created=mkdir(gen_dir,0777);
	}
	
	if (d_created==0)
	{
		g_print("\nCreating dir %s\n",gen_dir);	
		generate_area(gen_dir);
		gtk_object_destroy((GtkObject*)gen_dialog);
	}
	else		
	{
		mdialog_msg("Directory specified for generation doesnt exist\n");
	}

/*		
*/

}









void
on_entry4_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	char *hm;
	char *hmm;
	GtkWidget *e2, *ar_name;
	ar_name=lookup_widget(gen_dialog,"entry2");
	e2=lookup_widget(gen_dialog,"entry4");
	
	hm=getenv("HOME");
	hmm=malloc(sizeof(char)*(strlen(hmm)+200));

	strcpy(hmm,hm);
	strcat(hmm,"/.mudsbuilder/");
	strcat(hmm,(char*)gtk_entry_get_text((GtkEntry*)e2));
	strcat(hmm,"/");
	gtk_entry_set_text((GtkEntry*)ar_name,hmm);

	free(hm);
	free(hmm);
}


void
on_how_to1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GError *errr=NULL;
	gnome_help_display("README.html",NULL,&errr);
	if (errr!=NULL)	g_print(errr->message);
}




void
on_grid_helper1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{	
	GtkCheckMenuItem *tmp;
	tmp=(GtkCheckMenuItem*)menuitem;

	if (tmp->active) misactive=1;
	else misactive=0;

}




void
on_autoscroll1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkCheckMenuItem *tmp;
	tmp=(GtkCheckMenuItem*)menuitem;
	
	if (tmp->active) mautoscroll=1;
	else mautoscroll=0;
}




void
on_edit_exits_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	char *cex[]={ 
		SOUTHWEST_IS,
		SOUTH_IS,
		SOUTHEAST_IS,
		WEST_IS,
		EAST_IS,
		NORTHWEST_IS,
		NORTH_IS,
		NORTHEAST_IS};

	GtkWidget *treeview;
	struct _vexitnode *t_e_n;

	struct _vroom *tmp;
	int i;
	int gg;

	if (head==0)
	{
		mdialog_msg("Error: You must first create room");
		return;
	}
	eedlg=create_dialog4();
	gtk_widget_show(eedlg);
	
	
	treeview=lookup_widget(eedlg,"clist1");

	ee_row_selected=-1;

	gchar *_data[1][2];

	_data[0][0]=malloc(sizeof(char)*100);
	_data[0][1]=malloc(sizeof(char)*(100+strlen(AREA_NAME)));
	for (i=0; i<8; i++)
	{
		if (_curroom->room_ptr[i]!=0)
		{
			strcpy(_data[0][0],cex[i]);
			strcpy(_data[0][1],AREA_NAME);
			strcat(_data[0][1],_curroom->room_ptr[i]->id);
			gg=gtk_clist_append(
			(GtkCList*)treeview,_data[0]);
		}
	}
	
	if (_curroom->up) {
		strcpy(_data[0][0],UP_IS);
		strcpy(_data[0][1],AREA_NAME);
		strcat(_data[0][1],_curroom->up->id);
			gg=gtk_clist_append(
			(GtkCList*)treeview,_data[0]);
	}

	if (_curroom->down) {
		strcpy(_data[0][0],DOWN_IS);
		strcpy(_data[0][1],AREA_NAME);
		strcat(_data[0][1],_curroom->down->id);
			gg=gtk_clist_append(
			(GtkCList*)treeview,_data[0]);
	}


	t_e_n=_curroom->head_exit;
	
	while (t_e_n!=0)
	{
		
		strcpy(_data[0][0],t_e_n->ex_name);
		for (i=0; i<8; i++)
		{
			if (strcmp(t_e_n->ex_name,cex[i])==0)
			{
				strcat(_data[0][0]," (Misc)");
			}	
		}

		if (strcmp(t_e_n->ex_name,UP_IS)==0) strcat(_data[0][0]," (Misc)");
		if (strcmp(t_e_n->ex_name,DOWN_IS)==0) strcat(_data[0][0]," (Misc)");
		strcpy(_data[0][1],AREA_NAME);
		strcat(_data[0][1],t_e_n->room_ptr->id);
		t_e_n=t_e_n->next;
		
			gg=gtk_clist_append(
			(GtkCList*)treeview,_data[0]);
	}
	
	

	free(_data[0][0]);
	free(_data[0][1]);
}




void
on_remove_exit_btn_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *clist;
	if (ee_row_selected==-1)
	{
		mdialog_msg("Must select row to delete");
		return;
	}
	clist=lookup_widget(eedlg,"clist1");
	gtk_clist_remove((GtkCList*)clist,ee_row_selected);
	ee_row_selected=-1;
}




void
on_ee_cancel_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_object_destroy((GtkObject*)eedlg);
}


void
on_ee_ok_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
//apply changes here
	char *cex[]={ 
		SOUTHWEST_IS,
		SOUTH_IS,
		SOUTHEAST_IS,
		WEST_IS,
		EAST_IS,
		NORTHWEST_IS,
		NORTH_IS,
		NORTHEAST_IS};
	
	GtkWidget *clist;
	clist=lookup_widget(eedlg,"clist1");
	gchar *exx_name[100];
	gchar *room_name[100];
	int gg,i;
	int indx;
	indx=0;
	struct rtexits
	{
		char *name;
		struct rtexits *next;
	};	

	struct rtexits *rthead;
	struct rtexits *newrtexit;
	struct rtexits *tmprtexit;
	struct _vexitnode *tmpexnode;
	int ex_fnd;
	struct rtexits *rthead2;
	struct rtexits *t1,*t2;
	int ex_type;
	char buf[200];
	struct _vexitnode *oldvex;
	char tmpbuf[200];


	rthead=0;
	for (i=0; i<8; i++)
	{
		if (_curroom->room_ptr[i])
		{
			newrtexit=malloc(sizeof(struct rtexits));
			newrtexit->name=malloc(sizeof(char)*(strlen(cex[i])+2));
			strcpy(newrtexit->name,cex[i]);
			newrtexit->next=rthead;
			rthead=newrtexit;
		}
	}
	
	if (_curroom->up) 
	{
		
		newrtexit=malloc(sizeof(struct rtexits));
		newrtexit->name=malloc(sizeof(char)*(strlen(UP_IS)+2));
		strcpy(newrtexit->name,UP_IS);
		newrtexit->next=rthead;
		rthead=newrtexit;
	}

	if (_curroom->down)
	{
		newrtexit=malloc(sizeof(struct rtexits));
		newrtexit->name=malloc(sizeof(char)*(strlen(DOWN_IS)+2));
		strcpy(newrtexit->name,DOWN_IS);
		newrtexit->next=rthead;
		rthead=newrtexit;
		
	}
	
	tmpexnode=_curroom->head_exit;
	
	while (tmpexnode!=0)
	{
		newrtexit=malloc(sizeof(struct rtexits));
		newrtexit->name=malloc(sizeof(char)*(strlen(tmpexnode->ex_name)+20));
		strcpy(newrtexit->name,tmpexnode->ex_name);
		for (i=0; i<8; i++)
		{
			if (strcmp(tmpexnode->ex_name,cex[i])==0) strcat(newrtexit->name," (Misc)");
		}

		if (strcmp(tmpexnode->ex_name,UP_IS)==0) strcat(newrtexit->name," (Misc)");
		if (strcmp(tmpexnode->ex_name,DOWN_IS)==0) strcat(newrtexit->name," (Misc)");
		newrtexit->next=rthead;
		rthead=newrtexit;	
		tmpexnode=tmpexnode->next;
	}
	

	
	rthead2=0;
	do
	{
		gg=gtk_clist_get_text((GtkCList*)clist,indx++,0,exx_name);
		
		if (gg==1)
		{
				
		newrtexit=malloc(sizeof(struct rtexits));
		newrtexit->name=malloc(sizeof(char)*(strlen(*exx_name)+2));
		strcpy(newrtexit->name,*exx_name);
		newrtexit->next=rthead2;
		rthead2=newrtexit;	
		}	
	}
	while (gg==1);

	
	t1=rthead;
	t2=rthead2;

	while (t1!=0)
	{
		t2=rthead2;
		ex_fnd=0;
		while (t2!=0)
		{
			if (strcmp(t1->name,t2->name)==0) ex_fnd=1;
			t2=t2->next;
		}	
		
//		g_print("%s : %d\n",t1->name,ex_fnd);

		if (ex_fnd==0)
		{	
			ex_type=-1;
			memset(buf,0x0,200);
			strcpy(buf,t1->name);
		
				for (i=0; i<8; i++)
				{
					if (strcmp(t1->name,cex[i])==0) 
					{
				//		g_print("Found\n");
						ex_type=i;
						if (_curroom->rexit[i]) gtk_object_destroy((GtkObject*)_curroom->rexit[i]);
						if (_curroom->room_ptr[i]->rexit[7-i]) 
						gtk_object_destroy((GtkObject*) _curroom->room_ptr[i]->rexit[7-i]);	
	
						_curroom->room_ptr[i]->room_ptr[7-i]=0;
						_curroom->room_ptr[i]->rexit[7-i]=0;
						_curroom->room_ptr[i]=0;
						_curroom->rexit[i]=0;
					//	gnome_canvas_points_unref(_curroom->points[i]);
					}
				}			
			
				if (strcmp(t1->name,UP_IS)==0) 
				{
					ex_type=8;
					
					gtk_object_destroy((GtkObject*)_curroom->vup);
					gtk_object_destroy((GtkObject*)_curroom->up->vdown);
					_curroom->up->down=0;
					_curroom->up->vdown=0;
					_curroom->up=0;
					_curroom->vup=0;
				}

				if (strcmp(t1->name,DOWN_IS)==0) 
				{
				
					gtk_object_destroy((GtkObject*)_curroom->vdown);
					gtk_object_destroy((GtkObject*)_curroom->down->vup);
					_curroom->down->up=0;
					_curroom->down->vup=0;
					_curroom->down=0;
					_curroom->vdown=0;
					ex_type=9;
				}
				
		
			if (ex_type==-1)
			{
				
				tmpexnode=_curroom->head_exit;
				
			//	g_print("%s %s\n",t1->name,tmpbuf);
				oldvex=0;
				while (tmpexnode!=0)
				{
				memset(tmpbuf,0x0,200);
				strcpy(tmpbuf,tmpexnode->ex_name);
				strcat(tmpbuf," (Misc)");
					if (strcmp(tmpexnode->ex_name,t1->name)==0 ||
						strcmp(t1->name,tmpbuf)==0)
					{
				//		g_print("Found misc\n");	
						if (tmpexnode->prev) tmpexnode->prev->next=tmpexnode->next;
						else _curroom->head_exit=tmpexnode->next;
						
						if (tmpexnode->next) tmpexnode->next->prev=tmpexnode->prev;
						
						oldvex=tmpexnode;
					}
					tmpexnode=tmpexnode->next;
				}
				if (oldvex!=0)
				{
				free(oldvex->ex_name);
				gtk_object_destroy((GtkObject*)oldvex->line);
				free(oldvex);
				}
			}
		//	g_print("Ex type %d\n",ex_type);

		}

		t1=t1->next;
	}

	

	
	t1=rthead;
	t2=rthead2;
	while (t1!=0)
	{
		tmprtexit=t1;
		t1=t1->next;
		free(tmprtexit->name);
		free(tmprtexit);
	}

	while (t2!=0)
	{
		tmprtexit=t2;
		t2=t2->next;
		free(tmprtexit->name);
		free(tmprtexit);
	}
	gtk_object_destroy((GtkObject*)eedlg);
}


void
on_clist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	ee_row_selected=row;
}



void
on_export_ascii_map1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

	struct t_tmproom *room_srt;
	int *srt;
	int nroomz;
	struct _vroom *tmp;
	int *idz;
	int i;
	int oldy;
	int crx,cry;
	int oldx,k;
	char *l1,*l2;
	nroomz=0;
	tmp=head;

	while (tmp!=0)
	{
		if (tmp->rlevel==cur_level) nroomz++;
		tmp=tmp->next;
	}
	
//	srt=malloc(sizeof(int)*(nroomz));
	room_srt=malloc(sizeof(struct t_tmproom)*(nroomz));
	tmp=head;
	i=0;
	while (tmp!=0)
	{
		if (tmp->rlevel==cur_level)
		{	
			room_srt[i].val=
			(((tmp->y)/RSIZE2)+1)*(GSIZE)+(1+((tmp->x)/RSIZE2));
			room_srt[i].r_id=atoi(tmp->id);
			for (k=0; k<8; k++)
			{	
				if (tmp->room_ptr[k])
				room_srt[i].exits[k]=atoi(tmp->room_ptr[k]->id);
				else
				room_srt[i].exits[k]=0;
			}
			room_srt[i].exits[8]=0;
			room_srt[i].exits[9]=0;
			if (tmp->up) room_srt[i].exits[8]=1;
			if (tmp->down) room_srt[i].exits[9]=1;
			i++;
		}
		tmp=tmp->next;
	}

	g_print("-------------------------\n");
	
	mquicksort(room_srt,0,nroomz-1);
	
	oldx=0; oldy=0;
	l1=malloc(sizeof(char)*300);
	l2=malloc(sizeof(char)*300);
	for (i=0; i<nroomz; i++)
	{
		crx=room_srt[i].val%GSIZE;
		cry=room_srt[i].val/GSIZE;
		if (cry!=oldy) 
		{
			oldy=cry;
			printf("bam\n");
		}
	}

	free(l1); free(l2);

}
int show_ascii_room(int x, int y, int *_exitz)
{
	int i;
	if (_exitz[0]!=0) printf("-");
	if (_exitz[1]!=0) printf("\\");
}

int mquicksort(struct t_tmproom *aa, int p, int r)
{
	int q;
	if (p<r) 
	{
		q=mpartition(aa,p,r);
		mquicksort(aa,p,q-1);
		mquicksort(aa,q+1,r);
	}
}


int mpartition(struct t_tmproom *aa, int p, int r)
{
	int i,j;
	struct t_tmproom tmp;
	struct t_tmproom x;
	int k;
//	x=aa[r];	
//	x=(aa+r);
	
	x.val=aa[r].val;
	x.r_id=aa[r].r_id;
	for (k=0; k<10; k++) x.exits[k]=aa[r].exits[k];

	i=p-1;
	for (j=p;j<r; j++)
	{
		if (aa[j].val<=x.val)
		{
			i++;
			
			tmp.val=aa[i].val; 
			tmp.r_id=aa[i].r_id;
			for (k=0; k<10; k++) tmp.exits[k]=aa[i].exits[k];

			aa[i].val=aa[j].val; aa[i].r_id=aa[j].r_id;
			for (k=0; k<10; k++) aa[i].exits[k]=aa[j].exits[k];

			aa[j].val=tmp.val; aa[j].r_id=tmp.r_id;
			for (k=0; k<10; k++) aa[j].exits[k]=tmp.exits[k];
		//	tmp=aa[i];
		//	aa[i]=aa[j];
		//	aa[j]=tmp;
		}
	}

	tmp.val=aa[i+1].val; tmp.r_id=aa[i+1].r_id;
	for (k=0; k<10; k++) tmp.exits[k]=aa[i+1].exits[k];
	aa[i+1].val=aa[r].val; aa[i+1].r_id=aa[r].r_id;
	for (k=0; k<10; k++) aa[i+1].exits[k]=aa[r].exits[k];

	aa[r].val=tmp.val; aa[r].r_id=tmp.r_id;
	for (k=0; k<10; k++) aa[r].exits[k]=tmp.exits[k];


//	tmp=aa[i+1];
//	aa[i+1]=aa[r];
//	aa[r]=tmp;
	return i+1;
}
