#include "levels.h"
#include <gnome.h>
#include "defines.h"
#include "callbacks.h"
#include "vroom.h"
#include "statusbar.h"
extern notebook;

extern struct _level *cur_level;
extern struct _level *head_level;
extern struct _vroom *head;
extern struct _vroom *_curroom;
extern int misactive;

struct _level *new__level()
{
	struct _level *tmplev;
	tmplev=(struct _level*)malloc(sizeof(struct _level));
	tmplev->next=0;
	tmplev->prev=0;
	tmplev->line_list=malloc(sizeof(GnomeCanvasItem*)*(GSIZE*GSIZE+2));
	
	return tmplev;
}


int level_exists(char *name)
{
	int pages,i;


	GtkWidget *page_label;
	GtkWidget *child;

//Changed to 3 lines below due to bug report from Mats Larsson
//gtk_notebook_get_n_pages isnt in lib under Mandrake 9.0
//	pages=gtk_notebook_get_n_pages((GtkNotebook*)notebook);

	pages=0;
	while (gtk_notebook_get_nth_page((GtkNotebook*)notebook,pages))
	pages++;

	for  (i=0; i<pages; i++)
	{
		child=gtk_notebook_get_nth_page((GtkNotebook*)notebook,i);
		page_label=gtk_notebook_get_tab_label(
				(GtkNotebook*)notebook,child);
		if (strcmp(name, gtk_label_get_text((GtkLabel*)page_label))==0) 
		return i;
	}

	return -1;
}


int get_map_level(char *name)
{
	int bla;
	if (strcmp(name,"Main Level")==0) return 0;

	sscanf(name,"Level %i",&bla);
	return bla;
}


void get_current_level(char *name)
{
	int page_num;
	GtkWidget *page;
	GtkWidget *page_lab;
	
	page_num=gtk_notebook_get_current_page((GtkNotebook*)notebook);
	
	page=gtk_notebook_get_nth_page((GtkNotebook*)notebook,page_num);
	page_lab=gtk_notebook_get_tab_label((GtkNotebook*)notebook,page);
	strcpy(name,gtk_label_get_text((GtkLabel*)page_lab));
}



int go_level(int amount)
{
        double mx_scroll;
                                                                                
        GtkWidget *label;
        GtkWidget *frame;
        GtkWidget *table;
        GtkWidget *scrolled;
        GnomeCanvas *newcanvas;
        GnomeCanvasGroup *newgroup;
	GtkObject *aadj1,*aadj2;
        char curlname[30];
        char newlname[30];
        int mlevel;
        char lev_int[20];
        int lexists;
        struct _level *newlev;  
	struct _vroom *tmpvroom;
	struct _level *ltofind;
	extern root;
	int wx,wy;
	
        memset(curlname,0x0,30);
        get_current_level(curlname);
        mlevel=get_map_level(curlname);
        mlevel+=amount;
                                                                                
                                                                                
        sprintf(lev_int,"%i",mlevel);
                                                                                
        if (mlevel==0) strcpy(newlname,"Main Level");
        if (mlevel>0) {
                strcpy(newlname,"Level +");
                strcat(newlname,lev_int);
        }
       if (mlevel<0) {
                strcpy(newlname,"Level ");
                strcat(newlname,lev_int);
        }
                                                                                
                                                                                
        lexists=level_exists(newlname);
        if (lexists!=-1) {
                if (amount>0) {
		gtk_notebook_next_page(GTK_NOTEBOOK(notebook));
	   	//on_notebook1_switch_page in callbacks.c takes care of 
		//switching pages
		}
		
	   	if (amount<0) {
		gtk_notebook_prev_page(GTK_NOTEBOOK(notebook));
		}

		tmpvroom=head;
		
		if (amount>0) ltofind=_curroom->rlevel->next;
		if (amount<0) ltofind=_curroom->rlevel->prev;
		while (tmpvroom!=0)
		{
			if (
			tmpvroom->x==_curroom->x && 
			tmpvroom->y==_curroom->y &&
			ltofind==tmpvroom->rlevel)
			{	
				//just connecting 2 existing rooms one
				//above another
				if (amount>0 ) 
				{
					tmpvroom->down=_curroom;
					_curroom->up=tmpvroom;
					show_up(_curroom);
					show_down(tmpvroom);
				}

				if (amount<0)
				{
					tmpvroom->up=_curroom;
					_curroom->down=tmpvroom;
					show_up(tmpvroom);
					show_down(_curroom);
				}

				set_curroom(tmpvroom);
				return;
			}
			tmpvroom=tmpvroom->next;
			
		}


		if (tmpvroom==0)
		{
			create_new_room(amount);
		}

	} else {
                mx_scroll=GSIZE*RSIZE2;
                newcanvas=(GnomeCanvas*)gnome_canvas_new();
                gnome_canvas_set_scroll_region(
                (GnomeCanvas*)newcanvas,0.0,0.0,mx_scroll,mx_scroll);
                table=gtk_table_new(1,1,FALSE);

		aadj1=gtk_adjustment_new(0.0,0.0,1800.0,30.0,50.0,50.0);
		aadj2=gtk_adjustment_new(0.0,0.0,1800.0,30.0,50.0,50.0);
		
		scrolled=gtk_scrolled_window_new(
		(GtkAdjustment*)aadj2,(GtkAdjustment*)aadj1);
                gtk_container_add(
                GTK_CONTAINER(scrolled),GTK_WIDGET(newcanvas));
                gtk_widget_show(scrolled);
		label=gtk_label_new(newlname);
               	
               	newlev=new__level();
            
	    	if (amount>0)
		{
                gtk_notebook_append_page(
		GTK_NOTEBOOK(notebook),scrolled,label);              

		newlev->next=0;
		newlev->prev=cur_level;
		cur_level->next=newlev;
		}
		
		if (amount<0)
		{
                gtk_notebook_prepend_page(
		GTK_NOTEBOOK(notebook),scrolled,label);
 		
 		newlev->prev=0;
		newlev->next=cur_level;
		cur_level->prev=newlev;
       		}

		cur_level=newlev;
		cur_level->_zoom=1.0;
                newgroup=gnome_canvas_root((GnomeCanvas*)newcanvas);
                 

		cur_level->canvas=(GtkWidget*)newcanvas;
		cur_level->group=newgroup;
		cur_level->lev_id=mlevel;
		cur_level->table=table;
		cur_level->scrolled=scrolled;
                draw_grid(cur_level,GRID_COLOR);

		
                gtk_widget_show(GTK_WIDGET(newcanvas));
                if (amount>0)
                gtk_notebook_set_page(GTK_NOTEBOOK(notebook),-1);
                if (amount<0)
                gtk_notebook_set_page(GTK_NOTEBOOK(notebook),0);
	
		gtk_signal_connect( 
			(gpointer) cur_level->canvas,
			"button_press_event",
			G_CALLBACK (on_canvas1_button_press_event),
			NULL);
	
		create_new_room(amount);
	}
		
	gtk_window_get_size((GtkWindow*)root,&wx,&wy);
	gnome_canvas_scroll_to((GnomeCanvas*)cur_level->canvas,
	(_curroom->x)-wx/2,(_curroom->y)-wy/2);
}





int switch_to_current_level()
{
	int l1,l2,ldif;
	int i;

	l2=_curroom->rlevel->lev_id;
	l1=cur_level->lev_id;
	
	ldif=l2-l1;
	
	
	for (i=0; i<abs(ldif); i++)
	{
		if (ldif<0) gtk_notebook_prev_page((GtkNotebook*)notebook);
		if (ldif>0) gtk_notebook_next_page((GtkNotebook*)notebook);
	}
	
	
}


int level_destroy(struct _level *cl)
{

	GtkWidget* cpage;
	int cpagenum;
	struct _vroom *tmp;
	int lid;
	int rearrange;
	struct _level *rr;
	char labtxt[300];
	char oldlabtxt[300];
	int curpg;
	int i;
	GtkWidget *clabel;
	int ccl;
	char cch[30];


	memset(labtxt,0x0,300);
	lid=cl->lev_id;
	rearrange=lid;
	
	tmp=head;

	//caused segfault on some systems
	hide_helpers(0);
	if (lid==0) return -1;
	while (tmp!=0)
	{
		if (tmp->rlevel->lev_id==lid) { return -1; }
		tmp=tmp->next;
	}

	for (i=0; i<GSIZE; i++)
	{
		gtk_object_destroy((GtkObject*)(cl->line_list[i]));
		gtk_object_destroy((GtkObject*)(cl->line_list[GSIZE+i]));
		
	}

	gtk_object_destroy((GtkObject*)cl->canvas);
	

	cpagenum=gtk_notebook_get_current_page((GtkNotebook*)notebook);
	gtk_notebook_remove_page((GtkNotebook*)notebook,cpagenum);

	if (cl->prev) cl->prev->next=cl->next;
	else {rearrange=0;}
	if (cl->next) cl->next->prev=cl->prev;
	else {rearrange=0; }

	if (rearrange>0) rr=cl->next;
	if (rearrange<0) rr=cl->prev;
	
	free(cl);

	cl=cur_level;
	if (rearrange>0) {
		while (rr!=0)
		{
			rr->lev_id=rr->lev_id-1;
			cpage=gtk_notebook_get_nth_page((GtkNotebook*)notebook,cpagenum);
			strcpy(labtxt,"Level ");
			
			clabel=gtk_notebook_get_tab_label((GtkNotebook*)notebook,cpage);
			
			strcpy(oldlabtxt,gtk_label_get_text((GtkLabel*)clabel));
			ccl=get_map_level(oldlabtxt)-1;
			
			sprintf(cch,"%i",ccl);
			
			if (ccl>0) strcat(labtxt,"+");
			strcat(labtxt,cch);
			
			gtk_notebook_set_tab_label_text(
				(GtkNotebook*)notebook,cpage,labtxt);
			
			rr=rr->next;
			cpagenum++;
		}
	}

	if (rearrange<0) {
		cpagenum--;
		while (rr!=0)
		{
			rr->lev_id+=1;
			cpage=gtk_notebook_get_nth_page((GtkNotebook*)notebook,cpagenum);
		
			strcpy(labtxt,"Level ");
			clabel=gtk_notebook_get_tab_label((GtkNotebook*)notebook,cpage);
			strcpy(oldlabtxt,gtk_label_get_text((GtkLabel*)clabel));
			ccl=get_map_level(oldlabtxt)+1;
			sprintf(cch,"%i",ccl);
			
			strcat(labtxt,cch);

			gtk_notebook_set_tab_label_text((GtkNotebook*)notebook,cpage,labtxt);

			
			rr=rr->prev;
			cpagenum--;
		}
	}
	
	
	return 1;
}
